package ca.javajeff.lexan;

/**
 *  A token/lexeme pair.
 *
 *  @author Jeff Friesen
 */

public final class TokLex
{
   private String lexeme;

   private Token token;

   /**
    *  Initialize a toklex to a token/lexeme pair. 
    *
    *  @param token token to be stored in toklex
    *
    *  @param lexeme lexeme to be stored in toklex
    */

   public TokLex(Token token, String lexeme)
   {
      this.token = token;
      this.lexeme = lexeme;
   }

   /**
    *  Get this toklex's lexeme.
    *
    *  @return lexeme
    */

   public String getLexeme()
   {
      return lexeme;
   }

   /**
    *  Get this toklex's token.
    *
    *  @return token
    */

   public Token getToken()
   {
      return token;
   }
}